#ifndef DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__STATUS_DX_SECURITYSTATUSMESSAGE_INC
#define DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__STATUS_DX_SECURITYSTATUSMESSAGE_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "Dx_MarketMessage.h"

using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::timebase::api::messages::status {

class Dx_SecurityStatusMessage : public dx_BITTREX::deltix::timebase::api::messages::Dx_MarketMessage {
private:
    std::string __class_type__ = "deltix.timebase.api.messages.status.SecurityStatusMessage";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_1g";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        Dx_MarketMessage::decode(reader);
        has_cause_ = reader.readUTF8(cause_);
        has_exchangeId_ = reader.readAlphanumeric(exchangeId_, 10);
        has_originalStatus_ = reader.readUTF8(originalStatus_);
        status_ = reader.readEnum8();
    }

    virtual void encode(DataWriter &writer) {
        Dx_MarketMessage::encode(writer);
        writer.writeUTF8(has_cause_ ? &cause_ : NULL);
        has_exchangeId_ ? writer.writeAlphanumeric(10, exchangeId_) :  writer.writeAlphanumericNull(10);
        writer.writeUTF8(has_originalStatus_ ? &originalStatus_ : NULL);
        writer.writeEnum8(status_);
    }

    inline void clear() {
        Dx_MarketMessage::clear();
        cause_.clear();
        has_cause_ = false;
        exchangeId_.clear();
        has_exchangeId_ = false;
        originalStatus_.clear();
        has_originalStatus_ = false;
        status_ = DxApi::ENUM_NULL;
    }

    inline void setCause(const string &value) {
        this->cause_ = value;
        has_cause_ = true;
    }

    inline void setExchangeId(const string &value) {
        this->exchangeId_ = value;
        has_exchangeId_ = true;
    }

    inline void setOriginalStatus(const string &value) {
        this->originalStatus_ = value;
        has_originalStatus_ = true;
    }

    inline void setStatus(int value) {
        this->status_ = value;
    }

    virtual string toString() {
        stringstream ss;
        ss << Dx_MarketMessage::toString() << ", ";
        ss << "  cause_: "; 
        if (!has_cause_) { ss << "[NULL]"; } else { ss << cause_; }
        ss << ", ";
        ss << "  exchangeId_: "; 
        if (!has_exchangeId_) { ss << "[NULL]"; } else { ss << exchangeId_; }
        ss << ", ";
        ss << "  originalStatus_: "; 
        if (!has_originalStatus_) { ss << "[NULL]"; } else { ss << originalStatus_; }
        ss << ", ";
        ss << "  status_: "; 
        if (status_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << status_; }
        return ss.str();
    };

    string cause_;
    string exchangeId_;
    string originalStatus_;
    int status_;

    bool has_cause_ = false;
    bool has_exchangeId_ = false;
    bool has_originalStatus_ = false;
};

} // namespace dx_BITTREX::deltix::timebase::api::messages::status

#endif /* DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__STATUS_DX_SECURITYSTATUSMESSAGE_INC */
