#include <iostream>
#include <vector>
#include <ctime>

#include "dxapi/dxapi.h"

using namespace std;
using namespace DxApi;

char * timeMsToStr(time_t msTime, char *str, int strSize);

void liststreams() {
    try {
        // Create timebase connection
        unique_ptr<TickDb> db(TickDb::createFromUrl("dxtick://localhost:8001"));

        // Open in read-write mode
        db->open(false);

        // Get streams
        vector<TickStream *> streams = db->listStreams();
        for (int i = 0; i < streams.size(); i++) {
            TickStream *stream = streams[i];
            cout << "STREAM  key: " << stream->key() << endl;
            cout << "        Name: " << stream->name().get() << endl;
        }
    }
    catch (exception &e) {
        cout << e.what() << endl;
    }
    catch (...) {
        cout << "System exception" << endl;
    }
}

char * timeMsToStr(time_t msTime, char *str, int strSize) {
    time_t sTime = msTime / 1000;
    strftime(str, strSize, "%Y-%m-%d %H:%M:%S", gmtime(&sTime));
    return str;
}
